package cn.superdesk.uniorder.dao.entity.unified.settlement;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UnifiedSettlementProgrammeAmountRuleExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UnifiedSettlementProgrammeAmountRuleExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdIsNull() {
            addCriterion("programme_id is null");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdIsNotNull() {
            addCriterion("programme_id is not null");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdEqualTo(Long value) {
            addCriterion("programme_id =", value, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdNotEqualTo(Long value) {
            addCriterion("programme_id <>", value, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdGreaterThan(Long value) {
            addCriterion("programme_id >", value, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdGreaterThanOrEqualTo(Long value) {
            addCriterion("programme_id >=", value, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdLessThan(Long value) {
            addCriterion("programme_id <", value, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdLessThanOrEqualTo(Long value) {
            addCriterion("programme_id <=", value, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdIn(List<Long> values) {
            addCriterion("programme_id in", values, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdNotIn(List<Long> values) {
            addCriterion("programme_id not in", values, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdBetween(Long value1, Long value2) {
            addCriterion("programme_id between", value1, value2, "programmeId");
            return (Criteria) this;
        }

        public Criteria andProgrammeIdNotBetween(Long value1, Long value2) {
            addCriterion("programme_id not between", value1, value2, "programmeId");
            return (Criteria) this;
        }

        public Criteria andDisplayIsNull() {
            addCriterion("display is null");
            return (Criteria) this;
        }

        public Criteria andDisplayIsNotNull() {
            addCriterion("display is not null");
            return (Criteria) this;
        }

        public Criteria andDisplayEqualTo(Byte value) {
            addCriterion("display =", value, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayNotEqualTo(Byte value) {
            addCriterion("display <>", value, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayGreaterThan(Byte value) {
            addCriterion("display >", value, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayGreaterThanOrEqualTo(Byte value) {
            addCriterion("display >=", value, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayLessThan(Byte value) {
            addCriterion("display <", value, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayLessThanOrEqualTo(Byte value) {
            addCriterion("display <=", value, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayIn(List<Byte> values) {
            addCriterion("display in", values, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayNotIn(List<Byte> values) {
            addCriterion("display not in", values, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayBetween(Byte value1, Byte value2) {
            addCriterion("display between", value1, value2, "display");
            return (Criteria) this;
        }

        public Criteria andDisplayNotBetween(Byte value1, Byte value2) {
            addCriterion("display not between", value1, value2, "display");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsIsNull() {
            addCriterion("operator_ids is null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsIsNotNull() {
            addCriterion("operator_ids is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsEqualTo(String value) {
            addCriterion("operator_ids =", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsNotEqualTo(String value) {
            addCriterion("operator_ids <>", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsGreaterThan(String value) {
            addCriterion("operator_ids >", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsGreaterThanOrEqualTo(String value) {
            addCriterion("operator_ids >=", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsLessThan(String value) {
            addCriterion("operator_ids <", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsLessThanOrEqualTo(String value) {
            addCriterion("operator_ids <=", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsLike(String value) {
            addCriterion("operator_ids like", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsNotLike(String value) {
            addCriterion("operator_ids not like", value, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsIn(List<String> values) {
            addCriterion("operator_ids in", values, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsNotIn(List<String> values) {
            addCriterion("operator_ids not in", values, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsBetween(String value1, String value2) {
            addCriterion("operator_ids between", value1, value2, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorIdsNotBetween(String value1, String value2) {
            addCriterion("operator_ids not between", value1, value2, "operatorIds");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesIsNull() {
            addCriterion("operator_names is null");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesIsNotNull() {
            addCriterion("operator_names is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesEqualTo(String value) {
            addCriterion("operator_names =", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesNotEqualTo(String value) {
            addCriterion("operator_names <>", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesGreaterThan(String value) {
            addCriterion("operator_names >", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesGreaterThanOrEqualTo(String value) {
            addCriterion("operator_names >=", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesLessThan(String value) {
            addCriterion("operator_names <", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesLessThanOrEqualTo(String value) {
            addCriterion("operator_names <=", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesLike(String value) {
            addCriterion("operator_names like", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesNotLike(String value) {
            addCriterion("operator_names not like", value, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesIn(List<String> values) {
            addCriterion("operator_names in", values, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesNotIn(List<String> values) {
            addCriterion("operator_names not in", values, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesBetween(String value1, String value2) {
            addCriterion("operator_names between", value1, value2, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOperatorNamesNotBetween(String value1, String value2) {
            addCriterion("operator_names not between", value1, value2, "operatorNames");
            return (Criteria) this;
        }

        public Criteria andOrgIdsIsNull() {
            addCriterion("org_ids is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdsIsNotNull() {
            addCriterion("org_ids is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdsEqualTo(String value) {
            addCriterion("org_ids =", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsNotEqualTo(String value) {
            addCriterion("org_ids <>", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsGreaterThan(String value) {
            addCriterion("org_ids >", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsGreaterThanOrEqualTo(String value) {
            addCriterion("org_ids >=", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsLessThan(String value) {
            addCriterion("org_ids <", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsLessThanOrEqualTo(String value) {
            addCriterion("org_ids <=", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsLike(String value) {
            addCriterion("org_ids like", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsNotLike(String value) {
            addCriterion("org_ids not like", value, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsIn(List<String> values) {
            addCriterion("org_ids in", values, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsNotIn(List<String> values) {
            addCriterion("org_ids not in", values, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsBetween(String value1, String value2) {
            addCriterion("org_ids between", value1, value2, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgIdsNotBetween(String value1, String value2) {
            addCriterion("org_ids not between", value1, value2, "orgIds");
            return (Criteria) this;
        }

        public Criteria andOrgNamesIsNull() {
            addCriterion("org_names is null");
            return (Criteria) this;
        }

        public Criteria andOrgNamesIsNotNull() {
            addCriterion("org_names is not null");
            return (Criteria) this;
        }

        public Criteria andOrgNamesEqualTo(String value) {
            addCriterion("org_names =", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesNotEqualTo(String value) {
            addCriterion("org_names <>", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesGreaterThan(String value) {
            addCriterion("org_names >", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesGreaterThanOrEqualTo(String value) {
            addCriterion("org_names >=", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesLessThan(String value) {
            addCriterion("org_names <", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesLessThanOrEqualTo(String value) {
            addCriterion("org_names <=", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesLike(String value) {
            addCriterion("org_names like", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesNotLike(String value) {
            addCriterion("org_names not like", value, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesIn(List<String> values) {
            addCriterion("org_names in", values, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesNotIn(List<String> values) {
            addCriterion("org_names not in", values, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesBetween(String value1, String value2) {
            addCriterion("org_names between", value1, value2, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrgNamesNotBetween(String value1, String value2) {
            addCriterion("org_names not between", value1, value2, "orgNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsIsNull() {
            addCriterion("order_type_ids is null");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsIsNotNull() {
            addCriterion("order_type_ids is not null");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsEqualTo(String value) {
            addCriterion("order_type_ids =", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsNotEqualTo(String value) {
            addCriterion("order_type_ids <>", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsGreaterThan(String value) {
            addCriterion("order_type_ids >", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsGreaterThanOrEqualTo(String value) {
            addCriterion("order_type_ids >=", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsLessThan(String value) {
            addCriterion("order_type_ids <", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsLessThanOrEqualTo(String value) {
            addCriterion("order_type_ids <=", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsLike(String value) {
            addCriterion("order_type_ids like", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsNotLike(String value) {
            addCriterion("order_type_ids not like", value, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsIn(List<String> values) {
            addCriterion("order_type_ids in", values, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsNotIn(List<String> values) {
            addCriterion("order_type_ids not in", values, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsBetween(String value1, String value2) {
            addCriterion("order_type_ids between", value1, value2, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIdsNotBetween(String value1, String value2) {
            addCriterion("order_type_ids not between", value1, value2, "orderTypeIds");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesIsNull() {
            addCriterion("order_type_names is null");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesIsNotNull() {
            addCriterion("order_type_names is not null");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesEqualTo(String value) {
            addCriterion("order_type_names =", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesNotEqualTo(String value) {
            addCriterion("order_type_names <>", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesGreaterThan(String value) {
            addCriterion("order_type_names >", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesGreaterThanOrEqualTo(String value) {
            addCriterion("order_type_names >=", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesLessThan(String value) {
            addCriterion("order_type_names <", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesLessThanOrEqualTo(String value) {
            addCriterion("order_type_names <=", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesLike(String value) {
            addCriterion("order_type_names like", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesNotLike(String value) {
            addCriterion("order_type_names not like", value, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesIn(List<String> values) {
            addCriterion("order_type_names in", values, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesNotIn(List<String> values) {
            addCriterion("order_type_names not in", values, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesBetween(String value1, String value2) {
            addCriterion("order_type_names between", value1, value2, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNamesNotBetween(String value1, String value2) {
            addCriterion("order_type_names not between", value1, value2, "orderTypeNames");
            return (Criteria) this;
        }

        public Criteria andAmountRuleIsNull() {
            addCriterion("amount_rule is null");
            return (Criteria) this;
        }

        public Criteria andAmountRuleIsNotNull() {
            addCriterion("amount_rule is not null");
            return (Criteria) this;
        }

        public Criteria andAmountRuleEqualTo(Byte value) {
            addCriterion("amount_rule =", value, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleNotEqualTo(Byte value) {
            addCriterion("amount_rule <>", value, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleGreaterThan(Byte value) {
            addCriterion("amount_rule >", value, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleGreaterThanOrEqualTo(Byte value) {
            addCriterion("amount_rule >=", value, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleLessThan(Byte value) {
            addCriterion("amount_rule <", value, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleLessThanOrEqualTo(Byte value) {
            addCriterion("amount_rule <=", value, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleIn(List<Byte> values) {
            addCriterion("amount_rule in", values, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleNotIn(List<Byte> values) {
            addCriterion("amount_rule not in", values, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleBetween(Byte value1, Byte value2) {
            addCriterion("amount_rule between", value1, value2, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRuleNotBetween(Byte value1, Byte value2) {
            addCriterion("amount_rule not between", value1, value2, "amountRule");
            return (Criteria) this;
        }

        public Criteria andAmountRateIsNull() {
            addCriterion("amount_rate is null");
            return (Criteria) this;
        }

        public Criteria andAmountRateIsNotNull() {
            addCriterion("amount_rate is not null");
            return (Criteria) this;
        }

        public Criteria andAmountRateEqualTo(BigDecimal value) {
            addCriterion("amount_rate =", value, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateNotEqualTo(BigDecimal value) {
            addCriterion("amount_rate <>", value, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateGreaterThan(BigDecimal value) {
            addCriterion("amount_rate >", value, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("amount_rate >=", value, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateLessThan(BigDecimal value) {
            addCriterion("amount_rate <", value, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("amount_rate <=", value, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateIn(List<BigDecimal> values) {
            addCriterion("amount_rate in", values, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateNotIn(List<BigDecimal> values) {
            addCriterion("amount_rate not in", values, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("amount_rate between", value1, value2, "amountRate");
            return (Criteria) this;
        }

        public Criteria andAmountRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("amount_rate not between", value1, value2, "amountRate");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNull() {
            addCriterion("deleted is null");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNotNull() {
            addCriterion("deleted is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedEqualTo(Byte value) {
            addCriterion("deleted =", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotEqualTo(Byte value) {
            addCriterion("deleted <>", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThan(Byte value) {
            addCriterion("deleted >", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThanOrEqualTo(Byte value) {
            addCriterion("deleted >=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThan(Byte value) {
            addCriterion("deleted <", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThanOrEqualTo(Byte value) {
            addCriterion("deleted <=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedIn(List<Byte> values) {
            addCriterion("deleted in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotIn(List<Byte> values) {
            addCriterion("deleted not in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedBetween(Byte value1, Byte value2) {
            addCriterion("deleted between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotBetween(Byte value1, Byte value2) {
            addCriterion("deleted not between", value1, value2, "deleted");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}